
@import "CPString.j"

@import "CPExpression.j"
@import "CPExpression_operator.j"

@implementation CPExpression_assignment: CPExpression
{
   CPExpression _variable;
   CPExpression _expression;
}

- (id)initWithVariable:(CPExpression)variable expression:(CPExpression)expression
{
   _variable = variable;
   _expression = expression;
   
   return self;
}

+ (CPExpression)expressionWithVariable:(CPExpression)variable expression:(CPExpression)expression
{
   return [[self alloc] initWithVariable:variable expression:expression];
}

- (CPString)description
{
   var pretty = [_expression description];
   
   if ([_expression isKindOfClass:[CPExpression_operator class]])
            pretty = [CPString stringWithFormat:@"(%@)", pretty];
    
   return [CPString stringWithFormat:@"%@ := %@", _variable, pretty];
}

- (CPExpression)_expressionWithSubstitutionVariables:(CPDictionary)variables
{
// FIX?
   return self;
}

@end

